
/* ############################################################################# */

#define	farZ	oblv_ProjectionDepthRange_MAINPASS.x
#define	nearZ	oblv_ProjectionDepthRange_MAINPASS.y
#define	rangeZ	oblv_ProjectionDepthRange_MAINPASS.z
#define	sumZ	oblv_ProjectionDepthRange_MAINPASS.w
// .x - nearZ
// .y - farZ
// .z - farZ - nearZ
// .w - farZ + nearZ
float4 oblv_ProjectionDepthRange_MAINPASS;

// w = cot(fieldOfViewX / 2).
// h = w / aspectRatio.
//
// w       0       0                                                    0
// 0       h       0                                                    0
// 0       0                    zfarPlane / (znearPlane - zfarPlane)   -1
// 0       0       znearPlane * zfarPlane / (znearPlane - zfarPlane)    0
matrix oblv_ProjectionTransform_MAINPASS;

/* ############################################################################# */

texture2D oblv_CurrDepthStencilZ_MAINPASS;

sampler2D DpthSampler = sampler_state {
	texture = <oblv_CurrDepthStencilZ_MAINPASS>;

	AddressU = CLAMP;
	AddressV = CLAMP;

	MINFILTER = POINT;
	MAGFILTER = POINT;
	MIPFILTER = NONE;
};

/* ############################################################################# */

#define	ProjectionA	oblv_ProjectionTransform_MAINPASS[2][2]
#define	ProjectionB	oblv_ProjectionTransform_MAINPASS[3][2]

float LinearDepth(in float2 coord : TEXCOORD0) {
//	return (ProjectionB / (tex2D(DpthSampler, coord).x - ProjectionA)) / -rangeZ;
	return (ProjectionB / ((ProjectionA - tex2D(DpthSampler, coord).x) * rangeZ));
}
